EMACS(1)

NAME
emacs - GNU project Emacs

SYNOPSIS
emacs [file ...]

DESCRIPTION
GNU Emacs is a new version of Emacs, written by the author of the original (PDP-10) Emacs, Richard Stallman. Its user functionality encompasses everything other Emacs editors do, and it is easily extensible since its editing commands are written in Lisp.

Emacs has an extensive interactive help facility, but the facility assumes that you know how to manipulate Emacs windows and buffers. CTRL-h (backspace or CTRL-h) enters the Help facility. Help Tutorial (CTRL-h t) requests an interactive tutorial which can teach beginners the fundamentals of Emacs in a few minutes. Help Apropos (CTRL-h a) helps you find a command given its functionality, Help Character (CTRL-h c) describes a given character's effect, and Help Function (CTRL-h f) describes a given Lisp function specified by name.

Emacs's Undo can undo several steps of modification to your buffers, so it is easy to recover from editing mistakes.

GNU Emacs's many special packages handle mail reading (RMail) and sending (Mail), outline editing (Outline), compiling (Compile), running subshells within Emacs windows (Shell), running a Lisp read-eval-print loop (Lisp-Interaction-Mode), and automated psychotherapy (Doctor).

There is an extensive reference manual, but users of other Emacses should have little trouble adapting even without a copy. Users new to Emacs will be able to use basic features fairly rapidly by studying the tutorial and using the self-documentation features.

Emacs Options

The following options are of general interest:

file
    Edit file.

+number
    Go to the line specified by number (do not insert a space between the "+" sign and the number).

-d displayname
    Create the Emacs window on the display specified by displayname. This must be the first argument listed in the command line.

-q  Do not load an init file.

-u user
    Load user's init file.

-t file
    Use specified file as the terminal instead of using stdin/stdout. This must be the first argument specified in the command line.

The following options are lisp-oriented (these options are processed in the order encountered):

-f function
    Execute the lisp function function.

-l file
    Load the lisp code in the file file.

The following options are useful when running Emacs as a batch editor:

-batch commandfile
    Edit in batch mode using the commands found in commandfile. The editor will send messages to stdout. This option must be the first in the argument list.

-kill
    Exit Emacs while in batch mode.

Using Emacs with X

Emacs has been tailored to work well with the X window system. If you run Emacs from under X windows, it will create its own X window to display in. You will probably want to start the editor as a background process so that you can continue using your original window. Emacs can be started with the following X switches:

-r  Display the Emacs window in inverse video.

-i  Use the "kitchen sink" bitmap icon when iconifying the Emacs window.

-font font
    Set the Emacs window's font to that specified by font. You will find the various X fonts in the usrlibX11fonts directories. Note that Emacs will only accept fixed width fonts. xfontsel(1) is useful for displaying available fonts. When you specify a font, do not include the filename extension. Be sure to put a space between the -font switch and the font specification argument.
    e.g. -font 9x15

-b pixels
    Set the Emacs window's border width to the number of pixels specified by pixels.

-ib pixels
    Set the window's internal border width to the number of pixels specified by pixels. Defaults to one pixel of padding on each side of the window.

-w =[WIDTH][xHEIGHT][{+-}XOFF[{+-}YOFF]]
    Set the Emacs window's width, height, and position on the screen. The []'s denote optional arguments, the {}'s surround alternatives. WIDTH and HEIGHT are in number of characters, XOFF and YOFF are in pixels. WIDTH defaults to 80, HEIGHT to 24, XOFF and YOFF to 1. If you don't give XOFF and/or YOFF, then you must use the mouse to create the window. If you give XOFF and/or YOFF, then a WIDTHxHEIGHT window will automatically be creating without intervention. XOFF and YOFF specify deltas from a corner of the screen to the corresponding corner of the window, as follows:

    +XOFF+YOFF upper left to upper left
    -XOFF+YOFF upper right to upper right
    +XOFF-YOFF lower left to lower left
    -XOFF-YOFF lower right to lower right

-fg color
    On color displays, sets the color of the text.

-bg color
    On color displays, sets the color of the window's background. See the file usrlibX11rgb.txt for a list of valid color names.

-bd color
    On color displays, sets the color of the window's border.See the file usrlibX11rgb.txt for a list of valid color names.

-cr color
    On color displays, sets the color of the window's text cursor. See the file usrlibX11rgb.txt for a list of valid color names.

-ms color
    On color displays, sets the color of the window's mouse cursor. See the file usrlibX11rgb.txt for a list of valid color names.

-d displayname
    Create the Emacs window on the display specified by displayname. Must be the first option specified in the command line. -nw Tells Emacs not to use its special interface to X. If you use this switch when invoking Emacs from an xterm window, display is done in the xterm window. This must be the first option specified in the command line.

You can set X default values for your Emacs windows in your .Xdefaults file. Use the following format:

    emacs.keyword:value

where value specifies the default value of keyword. Emacs lets you set default values for the following keywords:

BodyFont
    Sets the window's text font.

ReverseVideo
    If ReverseVideo's value is set to on, the window will be displayed in inverse video.

BitMapIcon
    If BitMapIcon's value is set to on, the window will iconify into the "kitchen sink."

BorderWidth
    Sets the window's border width in pixels.

Foreground
    For color displays, sets the window's text color. See the file usrlibX11rgb.txt for a list of valid color names.

Background
    For color displays, sets the window's background color. See the file usrlibX11rgb.txt for a list of valid color names.

Border
    For color displays, sets the color of the window's border. See the file usrlibX11rgb.txt for a list of valid color names.

Cursor
    For color displays, sets the color of the window's text cursor. See the file usrlibX11rgb.txt for a list of valid color names.

Mouse
    For color displays, sets the color of the window's mouse cursor. See the file usrlibX11rgb.txt for a list of valid color names.

If you try to set color values while using a black and white display, the window's characteristics will default as follows: the foreground color will be set to black, the background color will be set to white, the border color will be set to grey, and the text and mouse cursors will be set to black.

Using the Mouse

The following lists the key bindings for the mouse cursor when used in an Emacs window.
MOUSE BUTTON             FUNCTION
left                     set point, selecting window if needed
middle                   paste text from X cut buffer
right                    put text between point and mouse pointer
                         into X cut buffer
SHIFT-middle             as middle
SHIFT-right              as right
CTRL-left                Select window with mouse, and delete all
                         other windows.  Same as typing
                         CTRL-x 1.
CTRL-middle              select this window, then split it into
                         two windows
CTRL-right               as right, but kill the text too

MANUALS

You can order printed copies of the GNU Emacs Manual for $15.00/copy
postpaid from the Free Software Foundation, which develops GNU software (contact them for quantity prices on the manual). Their address is:
    Free Software Foundation
    675 Mass Ave.
    Cambridge, MA 02139
Your local Emacs maintainer might also have copies available. As with all software and publications from FSF, everyone is permitted to make and distribute copies of the Emacs manual. The TeX source to the manual is also included in the Emacs source distribution.

FILES
/usr/lib/emacs/lisp - Lisp source files and compiled files that define most editing commands. Some are preloaded; others are autoloaded from this directory when used.

/usr/lib/emacs/etc - various programs that are used with GNU Emacs, and some files of information. /usr/lib/emacs/etc/DOC.* - contains the documentation strings for the Lisp primitives and preloaded Lisp functions of GNU Emacs. They are stored here to reduce the size of Emacs proper. /usr/lib/emacs/etc/DIFF discusses GNU Emacs vs. Twenex Emacs;
/usr/lib/emacs/etc/CCADIFF discusses GNU Emacs vs. CCA Emacs;
/usr/lib/emacs/etc/GOSDIFF discusses GNU Emacs vs. Gosling Emacs.
/usr/lib/emacs/etc/SERVICE lists people offering various services to assist users of GNU Emacs, including education, troubleshooting, porting and customization.
These files also have information useful to anyone wishing to write programs in the Emacs Lisp extension language, which has not yet been fully documented. /usr/lib/emacs/info - files for the Info documentation browser (a subsystem of Emacs) to refer to. Currently not much of Unix is documented here, but the complete text of the Emacs reference manual is included in a convenient tree structured form. /usr/lib/emacs/lock - holds lock files that are made for all files being modified in Emacs, to prevent simultaneous modification of one file by two users. /usr/lib/emacs/cpp - the GNU cpp, needed for building Emacs on certain versions of Unix where the standard cpp cannot handle long names for macros.

BUGS
There is a mailing list, bug-gnu-emacs@prep.ai.mit.edu on the internet (ucbvax!prep.ai.mit.edu!bug-gnu-emacs on UUCPnet), for reporting Emacs bugs and fixes. But before reporting something as a bug, please try to be sure that it really is a bug, not a misunderstanding or a deliberate feature. We ask you to read the section ``Reporting Emacs Bugs'' near the end of the reference manual (or Info system) for hints on how and when to report bugs. Also, include the version number of the Emacs you are running in every bug report that you send in. Do not expect a personal answer to a bug report. The purpose of reporting bugs is to get them fixed for everyone in the next release, if possible. For personal assistance, look in the SERVICE file (see above) for a list of people who offer it. Please do not send anything but bug reports to this mailing list. Send requests to be added to mailing lists to the special list info-gnu-emacs-request@prep.ai.mit.edu (or the corresponding UUCP address). For more information about Emacs mailing lists, see the file /usr/lib/emacs/etc/MAILINGLISTS. Bugs tend actually to be fixed if they can be isolated, so it is in your interest to report them in such a way that they can be easily reproduced.

Bugs that I know about are: shell will not work with programs running in Raw mode on some Unix versions.

UNRESTRICTIONS

Emacs is free; anyone may redistribute copies of Emacs to anyone under the terms stated in the Emacs General Public License, a copy of which accompanies each copy of Emacs and which also appears in the reference manual.

Copies of Emacs may sometimes be received packaged with distributions of Unix systems, but it is never included in the scope of any license covering those systems. Such inclusion violates the terms on which distribution is permitted. In fact, the primary purpose of the General Public License is to prohibit anyone from attaching any other restrictions to redistribution of Emacs.

Richard Stallman encourages you to improve and extend Emacs, and urges that you contribute your extensions to the GNU library. Eventually GNU (Gnu's Not Unix) will be a complete replacement for Berkeley Unix. Everyone will be able to use the GNU system for free.

AUTHORS

Emacs was written by Richard Stallman and the Free Software Foundation. Joachim Martillo and Robert Krawitz added the X features.